﻿
''' <summary> 
'''  Generische Exception mit genauen Daten über das Fehler-werfende Objekt.
''' </summary>
Public Class Exception(Of T) : Inherits System.Exception

    ''' <summary>
    ''' Stellt den Fehler-Werfenden fürs Debuggen zur Verfügung
    ''' </summary>
    Public ReadOnly Sender As T

    Public Sub New(ByVal sender As T, _
                   ByVal innerException As Exception, _
                   ByVal message As String)

        MyBase.New(String.Concat( _
           sender.GetType.Name, "-Exception", _
           If(String.IsNullOrEmpty(message), "", ": " & message)), innerException)
        Me.Sender = sender
    End Sub

End Class
