﻿Imports System.Runtime.CompilerServices

''' <summary> Extensions für alle Klassen </summary>
Public Module ObjectX

    <Extension()> _
    Public Function Exception(Of T)(ByVal sender As T, _
            ByVal firstMsgSegment As Object, _
            ByVal ParamArray msgSegments As Object()) As Exception(Of T)

        Return Exception(Of T)(sender, _
                               Nothing, _
                               firstMsgSegment, _
                               String.Concat(msgSegments))
    End Function

    <Extension()> _
    Public Function Exception(Of T)(
            ByVal sender As T, _
            ByVal innerException As Exception, _
            ByVal ParamArray msgSegments As Object()) As Exception(Of T)

        Return New Exception(Of T)(sender, innerException, String.Concat(msgSegments))
    End Function

    <Extension()> _
    Public Function Exception(Of T)(ByVal sender As T) As Exception(Of T)
        Return Exception(Of T)(sender, Nothing)
    End Function


    ''' <summary> 
    '''  Testet vor einer Zuweisung, ob der neue Wert überhaupt eine Änderung 
    '''   bringt.
    ''' </summary>
    ''' <remarks>
    '''  Nützlich bei Zuweisungen an rechenintensive Eigenschaften, 
    '''   oder wenn auf Änderungen reagiert werden muss.
    ''' </remarks>
    <Extension()> _
    Public Function Assign(Of T, T2 As T)(ByRef Dest As T, _
                                          ByVal Src As T2) As Boolean
        If Object.Equals(Dest, Src) Then Return False
        Dest = Src
        Return True
    End Function

End Module
